// LeftScrollbar by Ian Weiner, leftsb@hotmathematician.com 
// See license.txt for licensing info (GPL)

// todo: gmail, style/frames?

const lsbFF = 0; const lsbTB = 1; 

var lsbTabBrowserBox, lsbTabBrowser, lsbTabPanels, lsbTabContainer;
var lsbSB, lsbCurView, lsbInFcn=false, lsbOn=true;

const lsbPrefListener = {
  domain: "geckotip.leftsb.",
  observe: function(subject, topic, prefName) {
    lsbInit();
  }
}
var lsbPrefService = Components.classes["@mozilla.org/preferences-service;1"]
                     .getService(Components.interfaces.nsIPrefService);
var lsbPref = lsbPrefService.getBranch("geckotip.leftsb.");
var lsbPrefRoot = lsbPrefService.getBranch(null);
var lsbPbi = lsbPrefRoot.QueryInterface(Components.interfaces.nsIPrefBranchInternal);
lsbPbi.addObserver(lsbPrefListener.domain, lsbPrefListener, false);


function lsbInit() 
{
	var b, bu, bigsmall;

	lsbOn = lsbPref.getBoolPref("on");
	if (document.getElementById("lsb-toggle-option"))
		document.getElementById("lsb-toggle-option").setAttribute("hidden", !lsbPref.getBoolPref("toolsmenuitem"));

	// determine which app we're running under, firefox or thunderbird
	if (document.getElementById("main-window")) {
		lsbAppPlatform=lsbFF; 
		lsbTabBrowserBox = document.getElementById("appcontent");	
		lsbTabBrowser = document.getElementById("content");
		lsbTabPanels = lsbTabBrowser.mPanelContainer;
		lsbTabContainer = lsbTabBrowser.mTabContainer;
	} else { 
		lsbAppPlatform=lsbTB; 
		lsbTabBrowserBox = document.getElementById("messengerWindow");
		lsbTabPanels = document.getElementById("messagepane");
		lsbTabPanels = document.getElementById("messagepane");
		lsbTabBrowserBox = document.getElementById("messengerWindow");
	}

	lsbSB = document.getElementById("leftSB");
    /*if("@mozilla.org/content/style-sheet-service;1" in Components.classes) {
        var sss = Components.classes["@mozilla.org/content/style-sheet-service;1"]
                    .getService(Components.interfaces.nsIStyleSheetService);
        var ios = Components.classes["@mozilla.org/network/io-service;1"]
                    .getService(Components.interfaces.nsIIOService);
        var u = ios.newURI("chrome://leftsb/skin/leftsb.css", null, null);
	}*/
	

	if (lsbOn) {
		lsbSB.addEventListener("DOMAttrModified", lsbSBChangeHandler, false);
		lsbTabBrowserBox.addEventListener("DOMContentLoaded", lsbNewContent, false);
		lsbTabPanels.addEventListener("click", lsbClickHandler, false);
		lsbTabPanels.addEventListener("DOMAttrModified", lsbTabChange, false);		
		try { document.addEventListener("pageshow",lsbUpdateSB,false); } catch(err) { } // handle back/forward in FF1.5+
		/*if (sss) {
            if (!sss.sheetRegistered(u, sss.USER_SHEET)) {
                //sss.loadAndRegisterSheet(u, sss.USER_SHEET);
            }
        } */
	} else {
		lsbSB.removeEventListener("DOMAttrModified", lsbSBChangeHandler, false);
		lsbTabBrowserBox.removeEventListener("DOMContentLoaded", lsbNewContent, false);
		lsbTabPanels.removeEventListener("click", lsbClickHandler, false);
		lsbTabPanels.removeEventListener("DOMAttrModified", lsbTabChange, false);
		try { document.removeEventListener("pageshow",lsbUpdateSB,false); } catch(err) { }
		lsbSB.setAttribute("collapsed","true");
		/*if (sss) {
            if (sss.sheetRegistered(u, sss.USER_SHEET)) {
                sss.unregisterSheet(u, sss.USER_SHEET);
            }
        } */
	}
	
	try { 
		bu = document.getElementById("leftsb-button");
	  	bigsmall = "";
	  	try { bigsmall = ((bu.parentNode.getAttribute("iconsize")=="small")?"small":""); } catch(err) { }
	  	try { bu.style.removeProperty("list-style-image"); } catch(err) { }
    	bu.style.setProperty("list-style-image", "url(chrome://leftsb/skin/leftsb" + (lsbOn?"":"off") + bigsmall + ".png)", "important");	
   	} catch(err) { }
	
  	try {
   		if (lsbAppPlatform==lsbFF) {
     		for (var i=0; b = lsbTabBrowser.browsers[i]; i++) {
				try { lsbHandleDoc(b.contentDocument); } catch(err) { }
     		}
   		} else { 
			try { lsbHandleDoc(b.contentDocument); } catch(err) { }
   		}
	} catch(err) { }

	lsbCurView=lsbTabBrowser.selectedBrowser.contentDocument.defaultView;
	lsbUpdateSB();
}

/*
function lsbDOMChange(e)
{
	lsbUpdateSB();
}
*/

function lsbNewContent(e)
{
	// new page loaded in same tab
	if ((lsbCurView==null)&&(lsbTabBrowser.selectedBrowser.contentDocument==e.target)) {
		lsbCurView=e.target.defaultView;
	}

	lsbHandleDoc(e.target);
	lsbUpdateSB();
}

function lsbHandleDoc(doc)
{
	if (lsbOn) {
		//doc.defaultView.scrollbars.visible=false;
		doc.documentElement.addEventListener("scroll", lsbScrollHandler, false);
		doc.documentElement.addEventListener("DOMAttrModified", lsbUpdateSB, false);
		doc.documentElement.addEventListener("DOMNodeInserted", lsbUpdateSB, false);
		doc.documentElement.addEventListener("DOMNodeRemoved", lsbUpdateSB, false);
	} else {	
		//doc.defaultView.scrollbars.visible=true;
		doc.documentElement.removeEventListener("scroll", lsbScrollHandler, false);
		doc.documentElement.removeEventListener("DOMAttrModified", lsbUpdateSB, false);
		doc.documentElement.removeEventListener("DOMNodeInserted", lsbUpdateSB, false);
		doc.documentElement.removeEventListener("DOMNodeRemoved", lsbUpdateSB, false);
	}
}

function lsbUpdateSB()
{	
	if (lsbInFcn) return;
	if (!lsbOn) return;
	if (lsbCurView==null) return;
	lsbInFcn=true;

	try {
		var docEl = lsbCurView.document.documentElement;
		lsbSB.setAttribute("maxpos", docEl.scrollHeight-lsbCurView.innerHeight); //lsbCurView.scrollMaxY
		lsbSB.setAttribute("pageincrement", lsbCurView.innerHeight);
		lsbSB.setAttribute("curpos", lsbCurView.scrollY);
		lsbSB.setAttribute("collapsed", (lsbCurView.innerHeight < docEl.scrollHeight)?"false":"true");
	} catch(err) { }

	lsbInFcn=false;
}

function lsbScrollHandler(e)
{
	if (!lsbOn) return;
	if (lsbCurView != e.target.ownerDocument.defaultView) {
		lsbCurView = e.target.ownerDocument.defaultView;
	}
	lsbUpdateSB();
}

function lsbTabChange(e)
{
	if (e.attrName=="type" && e.newValue=="content-primary") {
		var doc=e.relatedNode.ownerElement.contentDocument;
		lsbCurView=doc.defaultView;
		doc.documentElement.addEventListener("scroll", lsbScrollHandler, false);

		lsbUpdateSB();
	}
}

function lsbClickHandler(e)
{
	var doc=e.target.ownerDocument;
	if (doc != document) {
		if (lsbCurView != e.target.ownerDocument.defaultView) {
			lsbCurView = e.target.ownerDocument.defaultView;
			lsbUpdateSB();
		}
	}
}

function lsbSBChangeHandler(e)
{
	if (lsbInFcn) return;
	if (lsbCurView) {
		lsbInFcn=true;
		try {
			lsbCurView.scrollTo(lsbCurView.scrollX,lsbSB.getAttribute("curpos"));
		} catch(err) {}
		lsbInFcn=false;
	}
}

function lsbToggle() {
   try { lsbPref.setBoolPref("on", !lsbOn); } catch(err) { }
}
